import java.awt.*;
 import javax.swing.*;
 import java.net.*;
 import java.io.*;
 import java.awt.event.*;
 import java.net.*;
 import java.util.*;
import java.util.Scanner;
 
 public class configurazione extends JFrame implements ActionListener{
 	//ISTANZIAMO TUTTI I COMPONENTI (GRAFICI E NON)
 	    JTextField txtSMTP = new JTextField(15);
 	    JTextField txtPortaSMTP = new JTextField(5);
 	    JTextField txtPOP3 = new JTextField(15);
 	    JTextField txtPortaPOP3 = new JTextField(5);
 	    JTextField txtIndirizzo = new JTextField(15);
 	    JTextField txtURL = new JTextField("C:/Programmi/ClientPosta");
 	    JPasswordField txtPassword = new JPasswordField(15);
 	    JButton btCanc = new JButton("Cancella");
 	    JButton btAvanti = new JButton("Avanti");
 	    JButton btFine = new JButton("Fine");
 	    Checkbox salvaPW = new Checkbox ("Salvare password", false);
 	    JPanel pan1 = new JPanel();
 	    JPanel pan2 = new JPanel();
 	    JPanel pan3 = new JPanel();
 	    int guidata = 0;
 	    String impostazioni = "Impostazioni \"Client di Posta\" di Ornaghi & Pasquandrea";
 	//COSTRUTTORE DELLA CLASSE
 	public configurazione(){
 		//OPZIONI DELLA FINESTRA (TITOLO, DIMENSIONI, POSIZIONE SULLO SCHERMO, ECC...)
 		try{
	         File pr = new File("config.bin");
	         FileInputStream fis=new FileInputStream(pr);
	         new invio();   
            }catch(FileNotFoundException ee){
 		                                     this.setTitle("Configurazione Guidata");
 		                                     this.setSize(600,500);
 		                                     this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
 		                                     this.setLocation(250,150);
 		                                     this.setVisible(true);
 		                                     this.setLayout(new BorderLayout());
 		                                     this.add("North", pan1);
 		                                     this.add("Center", pan3);
 		                                     this.add("South", pan2);
 		                                     pan1.setLayout(new GridLayout(20,1));
 		                                     pan1.add(new JLabel(" Benvenuto nella configurazione guidata,"));
 		                                     pan1.add(new JLabel(" seguendo passo passo le istruzioni di seguito imposterai il programma con i tuoi dati."));
 		                                     pan1.add(new JLabel(" Clicca su avanti per continuare"));
 		                                     pan2.setLayout(new FlowLayout());
 		                                     pan2.add(btCanc);
 		                                     pan2.add(btAvanti);
 		                                     btAvanti.addActionListener(this);
 		                                     btCanc.addActionListener(this);
 		                                     this.setVisible(true); 
            }
 	}
 	//ASCOLTATORE DI EVENTI
 	public void actionPerformed(ActionEvent e){
 		//SE VIENE PREMUTO IL BOTTONE "AVANTI", ESEGUE LE ISTRUZIONI CONTENUTE NEL SEGUENTE "IF(CONDIZIONE)"
 		if(e.getSource() == btAvanti){
 			try{
	             FileWriter pr = new FileWriter("config.bin",true);
                 BufferedWriter bw = new BufferedWriter(pr);
 			                           switch (guidata){
                                                        case 0: pan1.removeAll();
                                                                this.validate();
                                                                pan1.setLayout(new FlowLayout());
                                                        	    pan1.add(new JLabel("  Inserire il server di posta in uscita (SMTP):"));
                                                                pan1.add(txtSMTP);                                                                
                                                                pan3.add(new JLabel("  Porta da utilizzare:"));
                                                                pan3.add(txtPortaSMTP);
                                                                this.validate();
                                                                guidata++;
                                                                break;
                                                        case 1: bw.write(impostazioni);
                                                                bw.newLine();
                                                                bw.flush();
                                                                bw.write(txtSMTP.getText());
                                                                bw.newLine();
                                                                bw.flush();
                                                                bw.write(txtPortaSMTP.getText());
                                                                bw.newLine();
                                                                bw.flush();
                                                        	    pan1.removeAll();
                                                                pan3.removeAll();
                                                                this.validate();
                                                        	    pan1.add(new JLabel("  Inserire il server di posta in entrata (POP3):"));
                                                                pan1.add(txtPOP3);                                                                
                                                                pan3.add(new JLabel("  Porta da utilizzare:"));
                                                                pan3.add(txtPortaPOP3);
                                                                this.validate();
                                                                guidata++;
                                                        	    break;
                                                        case 2: bw.write(txtPOP3.getText());
                                                                bw.newLine();
                                                                bw.flush();
                                                                bw.write(txtPortaPOP3.getText());
                                                                bw.newLine();
                                                                bw.flush();
                                                        	    pan1.removeAll();
                                                                pan3.removeAll();
                                                                this.validate();
                                                        	    pan1.add(new JLabel("  Inserire l'indirizzo di posta:"));
                                                                pan1.add(txtIndirizzo);                                                                
                                                                pan3.add(new JLabel("  Password:"));
                                                                pan3.add(txtPassword);
                                                                pan3.add(salvaPW);
                                                                this.validate();
                                                                guidata++;
                                                        	    break;
                                                        case 3: bw.write(txtIndirizzo.getText());
                                                                bw.newLine();
                                                                bw.flush();
                                                                
                                                                if(salvaPW.getState()==true){
                                                                	bw.write(txtPassword.getText());
                                                                    bw.newLine();
                                                                    bw.flush();
                                                                }else{
                                                                	bw.write("#no password#");
                                                                    bw.newLine();
                                                                    bw.flush();
                                                                }
                                                        	    pan1.removeAll();
                                                                pan3.removeAll();
                                                                pan2.removeAll();
                                                                this.validate();
                                                        	    pan1.add(new JLabel("Completamento della configurazione guidata."));
                                                                pan3.add(new JLabel("E' stato salvato un file nella directory del programma con le impostazioni."));
                                                                pan2.add(btFine);
                                                                btFine.addActionListener(this);
                                                                this.validate();
                                                        	    break;
 			                           }
                bw.close();
 			}catch(IOException ee){}
 		}
 		
 		if(e.getSource() == btFine){
 			
                 
                 
                
 			this.setVisible(false);
 			new invio();
 		}
 		
 		
 		
 		if(e.getSource() == btCanc){
 			System.exit(0);
 		}
 	
 	
 	
 	}
 	//MAIN
 	public static void main (String[] args) {
 	   new configurazione();
 	}
 	
 	}
 	
 	