import java.awt.*;
 import javax.swing.*;
 import java.net.*;
 import java.net.Socket;
 import java.io.*;
 import java.awt.event.*;
 import java.net.*;
 import java.util.*;
import java.util.Scanner;
import java.util.Calendar;
import java.util.GregorianCalendar;
 
 public class invio extends JFrame implements ActionListener{
 	//ISTANZIAMO TUTTI I COMPONENTI (GRAFICI E NON)
 	    JMenuBar barraMenu = new JMenuBar();
 	    JMenu menuFile = new JMenu("File");
 	    JMenu menuConfig = new JMenu("Configurazione");
 	    JMenu menuAbout = new JMenu("Riconoscimenti");
 	    JMenuItem connetti = new JMenuItem("Connetti");
 	    JMenuItem disconetti = new JMenuItem("Disconnetti");
 	    JMenuItem newMsg = new JMenuItem("Nuovo messaggio");
 	    JMenuItem msgSend = new JMenuItem("Messaggi inviati");
 	    JMenuItem msgBox = new JMenuItem("Mailbox");
 	    JMenuItem closeClient = new JMenuItem("Chiudi");
 	    JMenuItem conf = new JMenuItem("Configurazione Manuale");
 	    JMenuItem about = new JMenuItem("About");
 	    JTextArea txtArea = new JTextArea(15,30);
 	    JPanel panTot = new JPanel();
 	    JPanel pan1 = new JPanel();
 	    JPanel pan2 = new JPanel();
 	    JPanel pan3 = new JPanel();
 	    JPanel pan4 = new JPanel();
 	    JScrollPane panScroll = new JScrollPane(txtArea);
 	    JTextField txtDestinatario = new JTextField(15);
 	    JTextField txtOggetto = new JTextField(15);
 	    boolean inviato = false;
 	    JButton btNewMsg = new JButton("Nuovo messaggio");
 	    JButton btSend = new JButton("Spedisci");
 	    JLabel lblStatus = new JLabel("Disconnesso");
 	    String strSMTP="";
 		String strPOP3="";
 		String strIndirizzo="";
 		String strPassword="#no password#";
 		String portaPOP3="";
 		String portaSMTP="";
 		int porPOP3=110, porSMTP=25, testConnessione=0, situazioneFinestra=0, invia=0,l=0;
 		Socket socketSMTP;
 		Socket socketPOP3;
 		PrintStream out;
 		BufferedReader in;
 		GregorianCalendar cal=new GregorianCalendar();
 		
 	    
 	//COSTRUTTORE DELLA CLASSE
 	public invio(){
 		//OPZIONI DELLA FINESTRA (TITOLO, DIMENSIONI, POSIZIONE SULLO SCHERMO, ECC...)
 		this.setTitle("Nuovo messaggio");
 		this.setLayout(new BorderLayout());
 		this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
 		menuFile.add(connetti);
 		menuFile.add(disconetti);
 		menuFile.add(newMsg);
 		menuFile.add(msgSend);
 		menuFile.add(msgBox);
 		menuFile.add(closeClient);
 		menuConfig.add(conf);
 		menuAbout.add(about);
 		barraMenu.add(menuFile);
 		barraMenu.add(menuConfig);
 		barraMenu.add(menuAbout);
 		pan1.setLayout(new GridLayout(2,2));
 		pan1.add(new JLabel("  Destinatario:"));
 		pan1.add(txtDestinatario);
 		pan1.add(new JLabel("  Oggetto:"));
 		pan1.add(txtOggetto);
 		panScroll.setBorder(BorderFactory.createTitledBorder("Testo del messaggio"));
 		txtArea.setLineWrap(true);
 		pan2.add(panScroll);
 		pan3.add(btNewMsg);
 		pan3.add(btSend);
 		pan4.add(lblStatus);
 		panTot.setLayout(new BorderLayout());
 		panTot.add("North", pan1);
 		panTot.add("Center", pan2);
 		panTot.add("South",pan3);
 		this.add("North", barraMenu);
 		this.add("West", panTot);
 		this.add("South", pan4);
 		
 		connetti.addActionListener(this);
 		disconetti.addActionListener(this);
 		newMsg.addActionListener(this);
 		msgSend.addActionListener(this);
 		msgBox.addActionListener(this);
 		btNewMsg.addActionListener(this);
 		btSend.addActionListener(this);
 		closeClient.addActionListener(this);
 		conf.addActionListener(this);
 		about.addActionListener(this);
 		
 		this.addWindowListener(new ascoltatoreFinestra());
 		this.setVisible(true);
 		this.pack();
 		this.setResizable(false);
 		
 		
 	}
 	
 	public void actionPerformed(ActionEvent e){
 		
 		if(e.getSource() == connetti){
 			lblStatus.setText("Connessione in corso...");
 			
 			try{
				    Scanner scf = new Scanner(new File("config.bin"));
                    scf.nextLine();
                    strSMTP=scf.nextLine().toString();
                    portaSMTP=scf.nextLine();
                    strPOP3=scf.nextLine().toString();
                    portaPOP3=scf.nextLine();
                    strIndirizzo=scf.nextLine().toString();
                    strPassword=scf.nextLine().toString();
                    scf.close();
 			}catch (IOException EX){JOptionPane.showMessageDialog(this,"ERRORE di lettura del file \"config.bin\"");}
 			porSMTP=Integer.parseInt(portaSMTP);
 			porPOP3=Integer.parseInt(portaPOP3);
 			while(strPassword.equals("#no password#")==true){
 		      strPassword=JOptionPane.showInputDialog(this,"PASSWORD:");
 		    }
 			try {
 				socketSMTP = new Socket(strSMTP,porSMTP);
 			    out = new PrintStream(socketSMTP.getOutputStream(), true);
                in = new BufferedReader(new InputStreamReader(socketSMTP.getInputStream()));   
 			}
            catch (Exception exception){lblStatus.setText("Connessione fallita.");}
            
 			lblStatus.setText("Connesso.");
 			testConnessione=1;
 		}
 		
 		if(e.getSource() == disconetti){
 			lblStatus.setText("Disconnessione in corso...");
 			try {
 				socketSMTP.close();
 			    socketPOP3.close();
 			    out.close();
 			    in.close();
 			}
            catch (Exception exception){lblStatus.setText("Errore durante la disconnessione.");}
 			lblStatus.setText("Disconnesso.");
 			testConnessione=0;
 		}
 		
 		if(e.getSource() == btSend){
 			
 			if(testConnessione==0){
 				JOptionPane.showMessageDialog(this,"Nessuna connessione attiva, fare clic su \"Connetti\" dal menu \"File\" per connettersi al server SMTP.");
 			}else{
 			   if(!txtDestinatario.equals("")){
 				try {
                    
                    socketSMTP = new Socket(strSMTP,porSMTP);
 			        out = new PrintStream(socketSMTP.getOutputStream(), true);
                    in = new BufferedReader(new InputStreamReader(socketSMTP.getInputStream()));
                    
                    String test=in.readLine();
                    if(test.substring(0,3).equals("220")==false){
                    	JOptionPane.showMessageDialog(this,"Non Connesso.");
                    	return;
                    }
                    String ip = socketSMTP.getLocalAddress().toString();
                    out.println("helo "+ip.substring(1));
                    test=in.readLine();
                    if(test.substring(0,3).equals("250")==false){
                    	JOptionPane.showMessageDialog(this,"Lautenticazione non  andata a buon fine.");
                    	return;
                    }
                    int libero=strIndirizzo.length()-9;
                    if(strIndirizzo.substring(libero).equals("libero.it")){
                    	out.println("MAIL FROM:<>");
                    }else{
                    	out.println("MAIL FROM:<"+strIndirizzo+">");
                    }
                    
                    test=in.readLine();
                    if(test.substring(0,3).equals("250")==false){
                    	JOptionPane.showMessageDialog(this,"Il mittente non  stato accettato.");
                    	return;
                    }
                    out.println("RCPT TO:<"+txtDestinatario.getText()+">");
                    test=in.readLine();
                    if(test.substring(0,3).equals("250")==false){
                    	JOptionPane.showMessageDialog(this,"Il destinatario non  stato accettato.");
                    	return;
                    }
                    out.println("DATA");
                    test=in.readLine();
                    if(test.substring(0,3).equals("354")==false){
                    	JOptionPane.showMessageDialog(this,"Il testo non  stato correttamente inserito.");
                    	return;
                    }
                    out.println("Date: "+cal.get(Calendar.DATE)+" "+(cal.get(Calendar.MONTH)+1)+" "+cal.get(Calendar.YEAR)+" ora: "+cal.get(Calendar.HOUR_OF_DAY)+":"+cal.get(Calendar.MINUTE)+":"+cal.get(Calendar.SECOND));                    
                    out.println("From: "+strIndirizzo);
                    out.println("To: "+txtDestinatario.getText());
                    out.println("Subject: "+txtOggetto.getText());
                    
                    out.println(txtArea.getText());
                    
                    out.print(".");
                    out.println("");
                    test=in.readLine();
                    if(test.substring(0,3).equals("250")){
                    	JOptionPane.showMessageDialog(this,"Messaggio inviato correttamente a: "+txtDestinatario.getText());
                    	inviato=true;
                    }else JOptionPane.showMessageDialog(this,"Messaggio NON inviato a: "+txtDestinatario.getText());

                    
                    
                    
 				}catch (Exception exception){JOptionPane.showMessageDialog(this,"ERRORE invio messaggio.\n"+exception);}
 			   }else JOptionPane.showMessageDialog(this,"Il destinatario non  specificato.");
 			   /***************************************************************/
 			   if(inviato==true){
 			   	      
                  try{                  	  
 			   	      new File("Inviati").mkdir();
 			   	      while(new File("Inviati/"+l+".txt").exists()){
                  	  	invia++;
                  	  	l++;
                  	  }
                      FileWriter outOnFile = new FileWriter("Inviati/"+invia+".txt");
                      BufferedWriter writeOnFile = new BufferedWriter(outOnFile);
                      writeOnFile.write("Destinatario: "+txtDestinatario.getText());
                      writeOnFile.newLine();
                      writeOnFile.write("Mittente: "+strIndirizzo);
                      writeOnFile.newLine();
                      writeOnFile.write("Giorno: "+cal.get(Calendar.DATE)+"-"+(cal.get(Calendar.MONTH)+1)+"-"+cal.get(Calendar.YEAR));
                      writeOnFile.newLine();
                      writeOnFile.write("Ora: "+cal.get(Calendar.HOUR_OF_DAY)+"-"+cal.get(Calendar.MINUTE)+"-"+cal.get(Calendar.SECOND));
                      writeOnFile.newLine();
                      writeOnFile.write("Oggetto: "+txtOggetto.getText());
                      writeOnFile.newLine();
                      writeOnFile.write("Testo: ");
                      writeOnFile.newLine();
                      writeOnFile.write(txtArea.getText());
                      writeOnFile.close();
                  }catch (Exception excep){}
                  /*****************************************************************/
                  txtDestinatario.setText("");
                  txtOggetto.setText("");
                  txtArea.setText("");
                  inviato=false;
 			   }
 			}
 		}
 		if(e.getSource() == btNewMsg || e.getSource() == newMsg){
 			txtDestinatario.setText("");
 			txtOggetto.setText("");
 			txtArea.setText("");
 		}
 		
 		if(e.getSource() == msgSend){
 			new inviati();
 		}
 		if(e.getSource() == conf){
 			if(testConnessione==1)JOptionPane.showMessageDialog(this,"Per poter cambiare la impostazioni bisogna prima disconnettersi.");
 			   else	new configurazioneManuale();
 		}
 		
 		if(e.getSource() == closeClient){
 		   if(JOptionPane.showConfirmDialog(this,"Sei sicuro di voler chiudere il programma?")==0){
 			  lblStatus.setText("Disconnessione in corso...");
 			  try{
 			   	  socketSMTP.close();
 			      socketPOP3.close();
 			      in.close();
 			      out.close();
 			  }catch(Exception exception){lblStatus.setText("Errore durante la disconnessione.");}
 			  lblStatus.setText("Disconnesso.");
 			  System.exit(0);
 		   }
 		}
 		
 		if(e.getSource() == about){
 			JOptionPane.showMessageDialog(this,"Questo programma:\n                                             \"Client di Posta Elettronica\" \n stato realizzato in linguaggio Java utilizzando JCreator 4.5 il 24/06/2010 da: \n                                   Ornaghi Andrea & Pasquandrea Claudio","Riconoscimenti",JOptionPane.PLAIN_MESSAGE);
 		}
 		
 		if(e.getSource() == msgBox){
 			if(testConnessione==1){
 			    try{
 			        socketPOP3 = new Socket(strPOP3,porPOP3);
                    new ricezione(socketPOP3, strIndirizzo, strPassword);
 			    }catch (Exception exception){JOptionPane.showMessageDialog(this,"Errore di connessiona alla mailbox.");}
 			}else JOptionPane.showMessageDialog(this,"Nessuna connessione attiva, fare clic su \"Connetti\" dal menu \"File\" per connettersi al server POP3.");
 		}
 	}
 	
 	 class ascoltatoreFinestra implements WindowListener{
         public void windowClosing(WindowEvent e){
 			lblStatus.setText("Disconnessione in corso...");
 			try {
 				socketSMTP.close();
 			    socketPOP3.close();
 			    in.close();
 			    out.close();
 			}
            catch (Exception exception){lblStatus.setText("Errore durante la disconnessione.");}
 			lblStatus.setText("Disconnesso.");
         e.getWindow().dispose();
         }
         public void windowClosed(WindowEvent e) {
         	    
                
         }
         public void windowOpened(WindowEvent e) {}
         public void windowIconified(WindowEvent e) {}
         public void windowDeiconified(WindowEvent e) {}
         public void windowActivated(WindowEvent e) {}
         public void windowDeactivated(WindowEvent e) {}
 	}
 	
 	//MAIN
 	public static void main (String[] args) {
 	   new invio();
 	}
 	
 	}
 	
 	